<?php

// VERSION: 1.20150825
require("CryptoPhotoUtils.php");

$server      = "https://cryptophoto.com";	
$public_key  = '__PUBLIC_KEY__';   // Get these from https://cryptophoto.com/admin/account
$private_key = '__PRIVATE_KEY__';
$uid         = '123456';           // This is the UserID of your customer. (It does not get revealed)

$cp = new CryptoPhotoUtils($server, $private_key, $public_key, $uid);

// get the IP address
// Adjust this to get the customer's IP address from your web server environment
if(array_key_exists('SERVER_ADDR', $_SERVER))
    $ip = $_SERVER['SERVER_ADDR'];
elseif(array_key_exists('LOCAL_ADDR', $_SERVER))
    $ip = $_SERVER['LOCAL_ADDR'];
elseif(array_key_exists('SERVER_NAME', $_SERVER))
    $ip = gethostbyname($_SERVER['SERVER_NAME']);
else {
    // Running CLI
    if(stristr(PHP_OS, 'WIN')) {
        $ip = gethostbyname(php_uname("n"));
    } else {
        $ifconfig = shell_exec('/sbin/ifconfig eth0');
        preg_match('/addr:([\d\.]+)/', $ifconfig, $match);
        $ip = $match[1];
    }
  }

// The below is for testing in a shell - remove this line if you put this into a web page
$ip = file_get_contents('https://cp.vu/show_my_ip');

// Request a new CryptoPhoto session
$resp = $cp->start_session($ip);

if($cp->is_valid) {
  echo "Session ID: ". $cp->sid ."\n";    // You need this for calls to CP

  echo "\n";

  $html = $cp->get_gen_widget();
  echo "Generate Token Form: ". $html ."\n";    // This is HTML for your web page to use
} 
else {
  echo "Error: ". $cp->error ."\n";
}

$resp = $cp->start_session($ip, true);

if($cp->is_valid) {
  echo "Session ID: ". $cp->sid ."\n";    // You need this for calls to CP

  echo "\n";

  $html = $cp->get_auth_widget();
  echo "Auth Token Form: ". $html ."\n";    // So is this

} 
else {
  echo "Error: ". $cp->error ."\n";
}

// Verifies the response to a given challenge
/* This is just a demo of how the function should be used;  without valid
 * parameters, it is natural that it will return an error message, it is
 * supposed to work when integrated with the login, when you provide
 * a real, valid IP and valid authentication codes 
 */
$cp->verify_response('selector', 'response_row', 'response_col', 'cp_phc', $ip);

echo "\n";

if($cp->is_valid) {
  echo "Authenticated\n";
}
else {
  echo "Error: ". $cp->error ."\n";
}

?>
